%global momorel 15
%global bash_completion_ver 20031215

Summary: The GNU Bourne Again shell (bash).
Name: bash

Version: 2.05b
Release: %{momorel}m
Group: System Environment/Shells
License: GPL
URL: http://www.gnu.org/directory/bash.html

%NoSource 0 ftp://ftp.gnu.org/pub/gnu/bash/bash-%{version}.tar.gz 5238251b4926d778dfe162f6ce729733
Source1: bashrc
%NoSource 2 ftp://ftp.gnu.org/pub/gnu/bash/bash-doc-%{version}.tar.gz 511b2d07f0f401f686e8edc551a8e47f
%NoSource 3 http://www.caliban.org/files/bash/bash-completion-%{bash_completion_ver}.tar.bz2 c01b45c4357e2de9d764a938d240ba88

Source10: dot-bashrc
Source11: dot-bash_profile
Source12: dot-bash_logout
Source13: dot-inputrc
Source14: tab.dot.bashrc

Patch0: bash-2.03-paths.patch
Patch1: bash-2.02-security.patch
Patch2: bash-2.04-arm.patch
Patch3: bash-2.03-profile.patch
Patch4: bash-2.05-readlinefixes.patch
Patch5: bash-2.05a-requires.patch
Patch6: bash-2.04-compat.patch
Patch7: bash-2.05a-shellfunc.patch
Patch8: bash-2.05-ia64.patch
Patch9: bash-2.05a-mailcheck.patch
Patch10: bash-2.05a-service_completion.patch
Patch11: bash-2.05a-loadables.patch
Patch12: bash-2.05a-interpreter.patch
Patch13: bash-2.05a-killbuiltin.patch
Patch14: bash-2.05b-strpbrk.patch
Patch16: bash-2.05b-avoid-loop.patch
Patch17: bash-2.05b-nls-setlocale.patch

%NoPatch 20 ftp://ftp.gnu.org/pub/gnu/bash/bash-2.05b-patches/bash205b-001 94e520fa0272b06fb03fc46042095b62
%NoPatch 21 ftp://ftp.gnu.org/pub/gnu/bash/bash-2.05b-patches/bash205b-002 2957bbe5f6db1830d649d1071baba63c
%NoPatch 22 ftp://ftp.gnu.org/pub/gnu/bash/bash-2.05b-patches/bash205b-003 2828e78563927b806246e2b4806ee0f5
%NoPatch 23 ftp://ftp.gnu.org/pub/gnu/bash/bash-2.05b-patches/bash205b-004 6bf89831209ba6d208943d2ebaa7fe3a
%NoPatch 24 ftp://ftp.gnu.org/pub/gnu/bash/bash-2.05b-patches/bash205b-005 311b7f0e3dabec51767bfabe6afd4ded
%NoPatch 25 ftp://ftp.gnu.org/pub/gnu/bash/bash-2.05b-patches/bash205b-006 f8a86d0a66b51080f3fbc5cc34ef1a06
%NoPatch 26 ftp://ftp.gnu.org/pub/gnu/bash/bash-2.05b-patches/bash205b-007 37d2acecc9146883f9b331c03b274f21

## patches for bash_completion
Patch50: bash-completion-configure.patch
Patch51: bash-completion-tar.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires(build): libtermcap-devel, autoconf

PreReq: libtermcap
Requires: mktemp
Provides: bash2
Provides: /bin/sh
Provides: /bin/bash
Obsoletes: bash2

%description
The GNU Bourne Again shell (Bash) is a shell or command language
interpreter that is compatible with the Bourne shell (sh). Bash
incorporates useful features from the Korn shell (ksh) and the C shell 
(csh). Most sh scripts can be run by bash without modification. This
package (bash) contains bash version %{version}, which improves POSIX
compliance over previous versions. However, many old shell scripts 
will depend upon the behavior of bash 1.14, which is included in the
bash1 package. Bash is the default shell for Red Hat Linux.  It is
popular and powerful, and you'll probably end up using it.

Documentation for bash version %{version} is contained in the bash-doc 
package.
#'

%package doc
Group: Documentation
Summary: Documentation for the GNU Bourne Again shell (bash) version %{version}
Obsoletes: bash2-doc

%description doc
The bash-doc package contains documentation for the GNU Bourne
Again shell version %{version}.

%prep

%setup -q -n bash-%{version} -a 2 -a 3
%patch0 -p1 -b .paths
%patch1 -p1 -b .security
#%%patch2 -p1 -b .arm
%patch3 -p1 -b .profile
#%%patch4 -p1 -b .readline
%patch5 -p1 -b .requires
%patch6 -p1 -b .compat
%patch7 -p1 -b .shellfunc
%patch8 -p1 -b .ia64
#%%patch9 -p1 -b .mailcheck
#%%patch10 -p1 -b .ipv6
%patch11 -p1 -b .loadables
%patch12 -p1 -b .interpreter
%patch14 -p1 -b .strpbrk
%patch16 -p1 -b .avoid-loop
%patch17 -p1 -b .setlocale

%patch20 -p0
%patch21 -p0
%patch22 -p0
%patch23 -p0
%patch24 -p0
%patch25 -p0
%patch26 -p0

(
  cd bash_completion
%patch50 -p1
%patch51 -p1
)

echo %{version} > _distribution
echo %{release} | %__sed -e 's/m$//g' > _patchlevel

%build
autoconf
%configure
%make

%install
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

# make prefix=%{buildroot}%{_prefix} install
%makeinstall

#chmod +w doc/texinfo.tex

# Take out irritating ^H's from the documentation
for i in `ls --color=no doc/`; do
  %__cat doc/$i > $i
  %__cat $i | %__perl -p -e 's/.//g' > doc/$i
  %__rm $i
done

# make manpages for bash builtins as per suggestion in DOC/README
(
  cd doc
  %__sed -e '
/^\.SH NAME/, /\\- bash built-in commands, see \\fBbash\\fR(1)$/{
/^\.SH NAME/d
s/^bash, //
s/\\- bash built-in commands, see \\fBbash\\fR(1)$//
s/,//g
b
}
d
' builtins.1 > man.pages
  for i in echo pwd test kill; do
    %__perl -pi -e "s,$i,,g" man.pages
    %__perl -pi -e "s,  , ,g" man.pages
  done
  %__install -c -m 644 builtins.1 %{buildroot}%{_mandir}/man1/builtins.1

  for i in `cat man.pages` ; do
    echo .so man1/builtins.1 > %{buildroot}%{_mandir}/man1/$i.1
    %__chmod 0644 %{buildroot}%{_mandir}/man1/$i.1
  done
# Not for printf (conflict with coreutils)
  %__rm -f %{buildroot}/%{_mandir}/man1/printf.1

# now turn man.pages into a filelist for the man subpackage
# cat man.pages |tr -s ' ' '\n' |sed '
# 1i\
# %%defattr(0644,root,man,0755)
# s:^:%{_prefix}/share/man/man1/:
# s/$/.1.gz/
# ' > ../man.pages
)
(
  cd %{buildroot}
  %__mkdir ./bin
  %__mv ./usr/bin/bash ./bin
  %__ln_s -f bash ./bin/bash2
  %__ln_s -f bash ./bin/sh
  strip ./bin/* || :
#  gzip -9nf .%{_prefix}/share/info/bash2.info
  %__rm -f .%{_infodir}/dir
)

%__mkdir_p %{buildroot}/etc
%__install -c -m644 %{SOURCE1} %{buildroot}%{_sysconfdir}/bashrc

# install completion files to /etc
%__install -c -m644 bash_completion/bash_completion %{buildroot}%{_sysconfdir}/
for i in bash_completion/contrib/*; do
  %__install -c -m644 $i %{buildroot}%{_sysconfdir}/bash_completion.`basename $i`
done

# for config-sample
%__mkdir_p %{buildroot}%{_datadir}/config-sample/bash
%__install -c -m644 %{SOURCE10} \
  %{buildroot}%{_datadir}/config-sample/bash/dot.bashrc
%__install -c -m644 %{SOURCE11} \
  %{buildroot}%{_datadir}/config-sample/bash/dot.bash_profile
%__install -c -m644 %{SOURCE12} \
  %{buildroot}%{_datadir}/config-sample/bash/dot.bash_logout
%__install -c -m644 %{SOURCE13} \
  %{buildroot}%{_datadir}/config-sample/bash/dot.inputrc
%__install -c -m644 %{SOURCE14} \
  %{buildroot}%{_datadir}/config-sample/bash/tab.dot.bashrc

%clean
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

%post
# ***** bash doesn't use install-info. It's always listed in %{_infodir}/dir
# to prevent prereq loops

HASBASH2=""
HASBASH=""
HASSH=""

if [ ! -f /etc/shells ]; then
  > /etc/shells
fi

(
  while read line ; do
    if [ $line = /bin/bash ]; then
      HASBASH=1
    elif [ $line = /bin/sh ]; then
      HASSH=1
    elif [ $line = /bin/bash2 ]; then
      HASBASH2=1
    fi
  done

  if [ -z "$HASBASH2" ]; then
    echo "/bin/bash2" >> /etc/shells
  fi
  if [ -z "$HASBASH" ]; then
    echo "/bin/bash" >> /etc/shells
  fi
  if [ -z "$HASSH" ]; then
    echo "/bin/sh" >> /etc/shells
  fi
) < /etc/shells

%postun
if [ "$1" = 0 ]; then
  # is "rm -f /etc/shells" better?
  %__grep -v '^/bin/bash2$' < /etc/shells | \
    %__grep -v '^/bin/bash$' | \
    %__grep -v '^/bin/sh$' > /etc/shells.new
  %__mv /etc/shells.new /etc/shells
fi

# %files -f man.pages
%files
%defattr(-,root,root)
%doc CHANGES COMPAT NEWS NOTES CWRU
%doc doc/FAQ doc/INTRO doc/article.ms
%doc examples/bashdb/ examples/functions/ examples/misc/
%doc examples/scripts.noah/ examples/scripts.v2/ examples/scripts/
%doc examples/startup-files/ examples/complete/ examples/loadables/
%doc bash_completion
%config /%{_sysconfdir}/bashrc
%{_sysconfdir}/bash_completion*
/bin/sh
/bin/bash
/bin/bash2
%{_prefix}/bin/bashbug
%{_infodir}/bash.info*
%{_mandir}/*/*
# I didn't know man ..
%{_mandir}/*/..1.*
%dir %{_datadir}/config-sample/bash
%{_datadir}/config-sample/bash/*

%files doc
%defattr(-,root,root)
%doc doc/*.ps doc/*.0 doc/*.html doc/article.txt

%changelog
* Sat Jul 31 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.05b-15m)
- update Source14: tab.dot.bashrc

* Tue May 18 2004 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.05b-14m)
- add patch 17 ([debian-devel:15370] bash initialization is wrong.)

* Tue Mar 15 2004 Toru Hoshina <t@momonga-linux.org>
- (2.05b-13m)
- revised spec for enabling rpm 4.2.

* Sat Dec 20 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (2.05b-12m)
- set prompt for screen in dot-bashrc
- update bash-completion to 20031215

* Thu Nov 06 2003 Kenta MURATA <muraken2@nifty.com>
- (2.05b-11m)
- add DISABLE_BASH_COMPLETION in %%{_sysconfdir}/bashrc.

* Fri Oct 31 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.05b-10m)
- renumber source
- rename dot files in config-sample dot-* => dot.*
- delete define prefix, why used this?
- update bashcompletion patch to 20031022

* Wed Aug 27 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (2.05b-9m)
- revise dot-inputrc

* Wed Aug 26 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (2.05b-8m)
- import official patches for 2.05b
- update bashcompletion patch to 20030821
- change my e-mail address from uomaster@nifty.com to zaki@zakky.org
- remove bash-2.05b-complete.patch. this bug is fixed by official patch

* Fri Mar 21 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (2.05b-7m)
- bash_completion: tar *x*f: include *.tar.bz2 *.tbz *.tb2 *.tbz2

* Sun Mar 16 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (2.05b-6m)
- autoconf before configure
- fix bashrc(by kaz)

* Sun Mar 16 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (2.05b-5m)
- source /etc/bash_completion from /etc/bashrc if interactive shell

* Sun Mar 16 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (2.05b-4m)
- update bash-completion to 20030227
- install bash-completion files to /etc (should be %%config?)

* Sat Nov 16 2002 Motonobu Ichimura <famao@momonga-linux.org>
- (2.05b-3m)
- add bash-2.05b-avoid-loop.patch

* Fri Aug 02 2002 Motonobu Ichimura <famao@momonga-linux.org>
- (2.05b-2m)
- add bash-2.05b-complete.patch
- this patch fixes a problem when do completion. 
  ex) '../[TAB]'

* Fri Jul 26 2002 Motonobu Ichimura <famao@momonga-linux.org>
- (2.05b-1m)
- up to 2.05b
- sync with rawhide (2.05b-1)
- add bash-2.05b-strpbrk.patch for more i18n support.
- add BuildPrereq: libtermcap-devel

* Sun May 9 2002 Toru Hoshina <t@kondara.org>
- (2.0.5-34k)
- revised bashrc.

* Wed May  1 2002 YAMAZAKI Makoto <zaki@kondara.org>
- (2.0.5-32k)
- add PreReq: libtermcap

* Tue Apr 30 2002 YAMAZAKI Makoto <zaki@kondara.org>
- (2.0.5-30k)
- Provides: /bin/bash

* Mon Apr 29 2002 Motonobu Ichimura <famao@kondara.org>
- (2.0.5-28k)
- update i18n patch (readline 0.4)

* Mon Apr 29 2002 Kenta MURATA <muraken@kondara.org>
- (2.0.5-26k)
- Provides: /bin/sh

* Sun Jan 20 2002 Motonobu Ichimura <famao@kondara.org>
- (2.0.5-24k)
- i18n patch (up to bash 0.5 readline 0.3)
- my patches included in it

* Wed Jan 16 2002 Motonobu Ichimura <famao@kondara.org>
- (2.0.5-22k)
- fix segfault when use Ctrl(t) with some locales

* Tue Dec 11 2001 Motonobu Ichimura <famao@kondara.org>
- (2.0.5-20k)
- modify i18n patch (TT)

* Mon Dec 10 2001 TABUCHI Takaaki <tab@kondara.org>
- (2.0.5-18k)
- add tab.dot.bashrc

* Mon Dec 10 2001 Motonobu Ichimura <famao@kondara.org>
- (2.0.5-16k)
- modify i18n-diff.patch

* Sun Dec 09 2001 Motonobu Ichimura <famao@kondara.org>
- (2.0.5-14k)
- re-enabled i18n patch
- added bash-i18n-diff.patch
- and re-added Source6 Source7 (still needed)

* Fri Nov 30 2001 Shingo Akagaki <dora@kondara.org>
- (2.0.5-12k)
- remove i18n patch

* Mon Nov 12 2001 Motonobu Ichimura <famao@kondara.org>
- (2.05-8k)
- add %dir %{_datadir}/config-sample/bash

* Thu Oct 25 2001 Toru Hoshina <t@kondara.org>
- (2.05-6k)
- dot files located properly.

* Thu Oct 25 2001 Motonobu Ichimura <famao@kondara.org>
- (2.05-4k)
- added IBM's I18n patches for bash-2.05

* Mon Oct 22 2001 Toru Hoshina <t@kondara.org>
- (2.05-2k)
- version up. no more etcskel.

* Fri Oct 12 2001 Masaru Sato <masachan@kondara.org>
- add URL tag

* Sun Aug 26 2001 Toru Hoshina <t@kondara.org>
- (2.04-28k)
- add kterm entry to /etc/bashrc...

* Mon May  7 2001 Akira Higuchi <a@kondara.org>
- (2.04-26k)
- removed IBM patches and re-enabled patch #6.

* Sun Mar 18 2001 Toru Hoshina <toru@df-usa.com>
- (2.04-24k)
- add IBM's I18n patches.
- turned off prereq grep.

* Sun Feb 18 2001 Kenichi Matsubara <m@kondara.org>
- (2.04-22k)
- backport 2.04-23k(Jirai).

* Sun Feb 18 2001 Kenichi Matsubara <m@kondara.org>
- (2.04-23k)
- Obsoletes bash2-doc.

* Thu Feb  1 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (2.04-21k)
- added '%post' (#854)

* Tue Jan 30 2001 Kenichi Matsubara <m@kondara.org>
- (2.04-19k)
- bugfix %files section.

* Fri Dec  1 2000 MATSUDA, Daiki <dyky@df-usa.com>
- (2.04-17k)
- modified to use %{_mandir} and %{_infodir} macro

* Tue Nov  7 2000 Toru Hoshina <toru@df-usa.com>
- Obsolete bash and replace bas with bash2.

* Wed Oct 25 2000 Kenichi Matsubara <m@kondara.org>
- remove create man.pages file section.
- modified %files section.

* Tue Aug 22 2000 Kenichi Matsubara <m@kondara.org>
- Change PATH (FHS).
- Obsolete jman files.

* Mon Aug 14 2000 Akira Higuchi <a@kondara.org>
- some changes in readline patch

* Tue Aug 01 2000 Akira Higuchi <a@kondara.org>
- some changes in readline patch

* Sun May 07 2000 Fumihiko Takayama <tekezo@catv296.ne.jp>
- i18n lib/readline. 

* Sat May 06 2000 Fumihiko Takayama <tekezo@catv296.ne.jp>
- now temporary change, del jp-patch and configure --with-installed-readilne

* Fri May 05 2000 Kenzi Cano <kc@furukawa.ch.kagu.sut.ac.jp>
- up tp 2.04 
- added jp-patch 

* Mon Apr 03 2000 TABUCHI Takaaki <tab@kondara.org>
- merge redhat-6.2 (2.0.3-8).

* Tue Mar  7 2000 Tenkou N. Hattori <tnh@kondara.org>
- add Prereq: grep.

* Wed Mar 1 2000 Masako Hattori <maru@kondara.org>
- change jman mv->cp

* Wed Feb 23 2000 Masako Hattori <maru@kondara.org>
- do not shake %{_mandir}/ja.

* Wed Feb 02 2000 Cristian Gafton <gafton@redhat.com>
- man pages are compressed
- fix description

* Mon Jan 31 2000 Masako Hattori <maru@kondara.org>
- add man-pages-ja-GNU_bash-20000115

* Sun Jan 22 2000 TABUCHI Takaaki <tab@kondara.org>
- be able to rebuild non-root user.

* Thu Dec  2 1999 Ken Estes <kestes@staff.mail.com>
- updated patch to detect what executables are required by a script.

* Wed Nov 24 1999 Tenkou N. Hattori <tnh@kondara.org>
- add man-pages-ja-GNU_bash-19991115

* Mon Nov 8 1999 Toru Hoshina <t@kondara.org>
- be a NoSrc :-P

* Fri Sep 14 1999 Dale Lovelace <dale@redhat.com>
- Remove annoying ^H's from documentation

* Fri Jul 16 1999 Ken Estes <kestes@staff.mail.com>
- patch to detect what executables are required by a script.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Fri Mar 19 1999 Jeff Johnson <jbj@redhat.com>
- strip binaries.
- include bash-doc correctly.

* Thu Mar 18 1999 Preston Brown <pbrown@redhat.com>
- fixed post/postun /etc/shells work.

* Thu Mar 18 1999 Cristian Gafton <gafton@redhat.com>
- updated again text in the spec file

* Mon Feb 22 1999 Jeff Johnson <jbj@redhat.com>
- updated text in spec file.
- update to 2.03.

* Fri Feb 12 1999 Cristian Gafton <gafton@redhat.com>
- build it as bash2 instead of bash

* Tue Feb  9 1999 Bill Nottingham <notting@redhat.com>
- set 'NON_INTERACTIVE_LOGIN_SHELLS' so profile gets read

* Thu Jan 14 1999 Jeff Johnson <jbj@redhat.com>
- rename man pages in bash-doc to avoid packaging conflicts (#606).

* Wed Dec 02 1998 Cristian Gafton <gafton@redhat.com>
- patch for the arm
- use $RPM_ARCH-redhat-linux as the build target

* Tue Oct  6 1998 Bill Nottingham <notting@redhat.com>
- rewrite %pre, axe %postun (to avoid prereq loops)

* Wed Aug 19 1998 Jeff Johnson <jbj@redhat.com>
- resurrect for RH 6.0.

* Sun Jul 26 1998 Jeff Johnson <jbj@redhat.com>
- update to 2.02.1

* Thu Jun 11 1998 Jeff Johnson <jbj@redhat.com>
- Package for 5.2.

* Mon Apr 20 1998 Ian Macdonald <ianmacd@xs4all.nl>
- added POSIX.NOTES doc file
- some extraneous doc files removed
- minor .spec file changes

* Sun Apr 19 1998 Ian Macdonald <ianmacd@xs4all.nl>
- upgraded to version 2.02
- Alpha, MIPS & Sparc patches removed due to lack of test platforms
- glibc & signal patches no longer required
- added documentation subpackage (doc)

* Fri Nov 07 1997 Donnie Barnes <djb@redhat.com>
- added signal handling patch from Dean Gaudet <dgaudet@arctic.org> that
  is based on a change made in bash 2.0.  Should fix some early exit
  problems with suspends and fg.

* Mon Oct 20 1997 Donnie Barnes <djb@redhat.com>
- added %clean

* Mon Oct 20 1997 Erik Troan <ewt@redhat.com>
- added comment explaining why install-info isn't used
- added mips patch 

* Fri Oct 17 1997 Donnie Barnes <djb@redhat.com>
- added BuildRoot

* Tue Jun 03 1997 Erik Troan <ewt@redhat.com>
- built against glibc
